Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 17803)
@@ -140,5 +140,6 @@
     <Compile Include="Implementation\ConstantModel.cs" />
     <Compile Include="Implementation\DataAnalysisModel.cs" />
-    <Compile Include="Implementation\Interval.cs" />
+    <Compile Include="Implementation\Interval\Interval.cs" />
+    <Compile Include="Implementation\Interval\IntervalCollection.cs" />
     <Compile Include="Implementation\Regression\ConfidenceBoundRegressionSolution.cs" />
     <Compile Include="Implementation\Regression\ConstantRegressionModel.cs" />
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval.cs	(revision 17495)
+++ 	(revision )
@@ -1,293 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Common;
-using HEAL.Attic;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  [StorableType("849e42d3-8934-419d-9aff-64ad81c06b67")]
-  public class Interval : IEquatable<Interval> {
-    [Storable]
-    public double LowerBound { get; private set; }
-    [Storable]
-    public double UpperBound { get; private set; }
-
-    [StorableConstructor]
-    protected Interval(StorableConstructorFlag _) { }
-
-    /// <summary>
-    /// Creates an interval with given bounds, where lower bound must be smaller than
-    /// the upper bound. Floating point precision errors trough calculations are fixed by,
-    /// checking if the intervals are almost the same (E-12). If this is the case, the bounds 
-    /// will be set to the bound closer to zero.
-    /// </summary>
-    /// <param name="lowerBound">Lower bound of the interval</param>
-    /// <param name="upperBound">Upper bound of the interval</param>
-    public Interval(double lowerBound, double upperBound) {
-      if (lowerBound.IsAlmost(upperBound)) {
-        //If the bounds go over zero
-        if (lowerBound <= 0 && upperBound >= 0) {
-          lowerBound = 0.0;
-          upperBound = 0.0;
-          //Interval is negative
-        } else if (upperBound < 0) {
-          lowerBound = upperBound;
-          //Interval is positive
-        } else {
-          upperBound = lowerBound;
-        }
-      }
-
-      if (lowerBound > upperBound)
-        throw new ArgumentException("LowerBound must be smaller than UpperBound.");
-
-      this.LowerBound = lowerBound;
-      this.UpperBound = upperBound;
-    }
-
-    public bool Contains(double value) {
-      return LowerBound <= value && value <= UpperBound;
-    }
-
-    public override string ToString() {
-      return "Interval: [" + LowerBound + ", " + UpperBound + "]";
-    }
-
-    public bool IsInfiniteOrUndefined {
-      get {
-        return double.IsInfinity(LowerBound) || double.IsInfinity(UpperBound) ||
-                double.IsNaN(LowerBound) || double.IsNaN(UpperBound);
-      }
-    }
-
-    /// <summary>
-    /// True if the interval is positive without zero
-    /// </summary>
-    public bool IsPositive {
-      get => LowerBound > 0.0; 
-    }
-
-    /// <summary>
-    /// True if the interval is negative without zero
-    /// </summary>
-    public bool IsNegative {
-      get => UpperBound < 0.0;
-    }
-
-    public static Interval GetInterval(IEnumerable<double> values) {
-      if (values == null) throw new ArgumentNullException("values");
-      if (!values.Any()) throw new ArgumentException($"No values are present.");
-
-      var min = double.MaxValue;
-      var max = double.MinValue;
-
-      foreach (var value in values) {
-        //If an value is NaN return an interval [NaN, NaN]
-        if (double.IsNaN(value)) return new Interval(double.NaN, double.NaN);
-
-        if (value < min) min = value;
-        if (value > max) max = value;
-      }
-
-      return new Interval(min, max);
-    }
-
-    #region Equals, GetHashCode, == , !=
-    public bool Equals(Interval other) {
-      if (other == null)
-        return false;
-
-      return (UpperBound.IsAlmost(other.UpperBound) || (double.IsNaN(UpperBound) && double.IsNaN(other.UpperBound)))
-        && (LowerBound.IsAlmost(other.LowerBound) || (double.IsNaN(LowerBound) && double.IsNaN(other.LowerBound)));
-    }
-
-    public override bool Equals(object obj) {
-      return Equals(obj as Interval);
-    }
-
-    public override int GetHashCode() {
-      return LowerBound.GetHashCode() ^ UpperBound.GetHashCode();
-    }
-
-    public static bool operator ==(Interval interval1, Interval interval2) {
-      if (ReferenceEquals(interval1, null)) return ReferenceEquals(interval2, null);
-      return interval1.Equals(interval2);
-    }
-    public static bool operator !=(Interval interval1, Interval interval2) {
-      return !(interval1 == interval2);
-    }
-    #endregion
-
-    #region operations
-
-    // [x1,x2] + [y1,y2] = [x1 + y1,x2 + y2]
-    public static Interval Add(Interval a, Interval b) {
-      return new Interval(a.LowerBound + b.LowerBound, a.UpperBound + b.UpperBound);
-    }
-
-    // [x1,x2] − [y1,y2] = [x1 − y2,x2 − y1]
-    public static Interval Subtract(Interval a, Interval b) {
-      return new Interval(a.LowerBound - b.UpperBound, a.UpperBound - b.LowerBound);
-    }
-
-    // [x1,x2] * [y1,y2] = [min(x1*y1,x1*y2,x2*y1,x2*y2),max(x1*y1,x1*y2,x2*y1,x2*y2)]
-    public static Interval Multiply(Interval a, Interval b) {
-      double v1 = a.LowerBound * b.LowerBound;
-      double v2 = a.LowerBound * b.UpperBound;
-      double v3 = a.UpperBound * b.LowerBound;
-      double v4 = a.UpperBound * b.UpperBound;
-
-      double min = Math.Min(Math.Min(v1, v2), Math.Min(v3, v4));
-      double max = Math.Max(Math.Max(v1, v2), Math.Max(v3, v4));
-      return new Interval(min, max);
-    }
-
-    //Division by intervals containing 0 is implemented as defined in
-    //http://en.wikipedia.org/wiki/Interval_arithmetic
-    public static Interval Divide(Interval a, Interval b) {
-      if (b.Contains(0.0)) {
-        if (b.LowerBound.IsAlmost(0.0)) return Interval.Multiply(a, new Interval(1.0 / b.UpperBound, double.PositiveInfinity));
-        else if (b.UpperBound.IsAlmost(0.0)) return Interval.Multiply(a, new Interval(double.NegativeInfinity, 1.0 / b.LowerBound));
-        else return new Interval(double.NegativeInfinity, double.PositiveInfinity);
-      }
-      return Interval.Multiply(a, new Interval(1.0 / b.UpperBound, 1.0 / b.LowerBound));
-    }
-
-    public static Interval Sine(Interval a) {
-      if (Math.Abs(a.UpperBound - a.LowerBound) >= Math.PI * 2) return new Interval(-1, 1);
-
-      //divide the interval by PI/2 so that the optima lie at x element of N (0,1,2,3,4,...)
-      double Pihalf = Math.PI / 2;
-      Interval scaled = Interval.Divide(a, new Interval(Pihalf, Pihalf));
-      //move to positive scale
-      if (scaled.LowerBound < 0) {
-        int periodsToMove = Math.Abs((int)scaled.LowerBound / 4) + 1;
-        scaled = Interval.Add(scaled, new Interval(periodsToMove * 4, periodsToMove * 4));
-      }
-
-      double scaledLowerBound = scaled.LowerBound % 4.0;
-      double scaledUpperBound = scaled.UpperBound % 4.0;
-      if (scaledUpperBound < scaledLowerBound) scaledUpperBound += 4.0;
-      List<double> sinValues = new List<double>();
-      sinValues.Add(Math.Sin(scaledLowerBound * Pihalf));
-      sinValues.Add(Math.Sin(scaledUpperBound * Pihalf));
-
-      int startValue = (int)Math.Ceiling(scaledLowerBound);
-      while (startValue < scaledUpperBound) {
-        sinValues.Add(Math.Sin(startValue * Pihalf));
-        startValue += 1;
-      }
-
-      return new Interval(sinValues.Min(), sinValues.Max());
-    }
-    public static Interval Cosine(Interval a) {
-      return Interval.Sine(Interval.Add(a, new Interval(Math.PI / 2, Math.PI / 2)));
-    }
-    public static Interval Tangens(Interval a) {
-      return Interval.Divide(Interval.Sine(a), Interval.Cosine(a));
-    }
-    public static Interval HyperbolicTangent(Interval a) {
-      return new Interval(Math.Tanh(a.LowerBound), Math.Tanh(a.UpperBound));
-    }
-
-    public static Interval Logarithm(Interval a) {
-      return new Interval(Math.Log(a.LowerBound), Math.Log(a.UpperBound));
-    }
-    public static Interval Exponential(Interval a) {
-      return new Interval(Math.Exp(a.LowerBound), Math.Exp(a.UpperBound));
-    }
-
-    public static Interval Power(Interval a, Interval b) {
-      if (a.Contains(0.0) && b.LowerBound < 0) return new Interval(double.NaN, double.NaN);
-
-      int bLower = (int)Math.Round(b.LowerBound);
-      int bUpper = (int)Math.Round(b.UpperBound);
-
-      List<double> powerValues = new List<double>();
-      powerValues.Add(Math.Pow(a.UpperBound, bUpper));
-      powerValues.Add(Math.Pow(a.UpperBound, bUpper - 1));
-      powerValues.Add(Math.Pow(a.UpperBound, bLower));
-      powerValues.Add(Math.Pow(a.UpperBound, bLower + 1));
-
-      powerValues.Add(Math.Pow(a.LowerBound, bUpper));
-      powerValues.Add(Math.Pow(a.LowerBound, bUpper - 1));
-      powerValues.Add(Math.Pow(a.LowerBound, bLower));
-      powerValues.Add(Math.Pow(a.LowerBound, bLower + 1));
-
-      return new Interval(powerValues.Min(), powerValues.Max());
-    }
-
-    public static Interval Square(Interval a) {
-      if (a.UpperBound <= 0) return new Interval(a.UpperBound * a.UpperBound, a.LowerBound * a.LowerBound);     // interval is negative
-      else if (a.LowerBound >= 0) return new Interval(a.LowerBound * a.LowerBound, a.UpperBound * a.UpperBound); // interval is positive
-      else return new Interval(0, Math.Max(a.LowerBound * a.LowerBound, a.UpperBound * a.UpperBound)); // interval goes over zero
-    }
-
-    public static Interval Cube(Interval a) {
-      return new Interval(Math.Pow(a.LowerBound, 3), Math.Pow(a.UpperBound, 3));
-    }
-
-    public static Interval Root(Interval a, Interval b) {
-      int lower = (int)Math.Round(b.LowerBound);
-      int higher = (int)Math.Round(b.UpperBound);
-
-      return new Interval(Math.Pow(a.LowerBound, 1.0 / higher), Math.Pow(a.UpperBound, 1.0 / lower));
-    }
-
-    public static Interval SquareRoot(Interval a) {
-      if (a.LowerBound < 0) return new Interval(double.NaN, double.NaN);
-      return new Interval(Math.Sqrt(a.LowerBound), Math.Sqrt(a.UpperBound));
-    }
-
-    public static Interval CubicRoot(Interval a) {
-      var lower = (a.LowerBound < 0) ? -Math.Pow(-a.LowerBound, 1d / 3d) : Math.Pow(a.LowerBound, 1d / 3d);
-      var upper = (a.UpperBound < 0) ? -Math.Pow(-a.UpperBound, 1d / 3d) : Math.Pow(a.UpperBound, 1d / 3d);
-
-      return new Interval(lower, upper);
-    }
-
-    public static Interval Absolute(Interval a) {
-      var absLower = Math.Abs(a.LowerBound);
-      var absUpper = Math.Abs(a.UpperBound);
-      var min = Math.Min(absLower, absUpper);
-      var max = Math.Max(absLower, absUpper);
-
-      if (a.Contains(0.0)) {
-        min = 0.0;
-      }
-
-      return new Interval(min, max);
-    }
-
-    public static Interval AnalyticalQuotient(Interval a, Interval b) {
-      var dividend = a;
-      var divisor = Add(Square(b), new Interval(1.0, 1.0));
-      divisor = SquareRoot(divisor);
-
-      var quotient = Divide(dividend, divisor);
-      return quotient;
-    }
-    #endregion
-  }
-}
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17803)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17803)
@@ -0,0 +1,279 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  [StorableType("849e42d3-8934-419d-9aff-64ad81c06b67")]
+  public class Interval : IEquatable<Interval> {
+    [Storable]
+    public double LowerBound { get; private set; }
+    [Storable]
+    public double UpperBound { get; private set; }
+
+    [StorableConstructor]
+    protected Interval(StorableConstructorFlag _) { }
+
+    /// <summary>
+    /// Creates an interval with given bounds, where lower bound must be smaller than
+    /// the upper bound. Floating point precision errors trough calculations are fixed by,
+    /// checking if the intervals are almost the same (E-12). If this is the case, the bounds 
+    /// will be set to the bound closer to zero.
+    /// </summary>
+    /// <param name="lowerBound">Lower bound of the interval</param>
+    /// <param name="upperBound">Upper bound of the interval</param>
+    public Interval(double lowerBound, double upperBound) {
+      if (lowerBound.IsAlmost(upperBound)) {
+        //If the bounds go over zero
+        if (lowerBound <= 0 && upperBound >= 0) {
+          lowerBound = 0.0;
+          upperBound = 0.0;
+          //Interval is negative
+        } else if (upperBound < 0) {
+          lowerBound = upperBound;
+          //Interval is positive
+        } else {
+          upperBound = lowerBound;
+        }
+      }
+
+      if (lowerBound > upperBound)
+        throw new ArgumentException("lowerBound must be smaller than or equal to upperBound.");
+
+      this.LowerBound = lowerBound;
+      this.UpperBound = upperBound;
+    }
+
+    public bool Contains(double value) {
+      return LowerBound <= value && value <= UpperBound;
+    }
+
+    public bool Contains(Interval other) {
+      if (double.IsNegativeInfinity(LowerBound) && double.IsPositiveInfinity(UpperBound)) return true;
+      if (other.LowerBound >= LowerBound && other.UpperBound <= UpperBound) return true;
+  
+      return false;
+    }
+
+    public override string ToString() {
+      return "Interval: [" + LowerBound + ", " + UpperBound + "]";
+    }
+
+    public bool IsInfiniteOrUndefined {
+      get {
+        return double.IsInfinity(LowerBound) || double.IsInfinity(UpperBound) ||
+                double.IsNaN(LowerBound) || double.IsNaN(UpperBound);
+      }
+    }
+
+    /// <summary>
+    /// True if the interval is positive without zero
+    /// </summary>
+    public bool IsPositive {
+      get => LowerBound > 0.0; 
+    }
+
+    /// <summary>
+    /// True if the interval is negative without zero
+    /// </summary>
+    public bool IsNegative {
+      get => UpperBound < 0.0;
+    }
+
+    public static Interval GetInterval(IEnumerable<double> values) {
+      if (values == null) throw new ArgumentNullException("values");
+      if (!values.Any()) throw new ArgumentException($"No values are present.");
+
+      var min = double.MaxValue;
+      var max = double.MinValue;
+
+      foreach (var value in values) {
+        //If an value is NaN return an interval [NaN, NaN]
+        if (double.IsNaN(value)) return new Interval(double.NaN, double.NaN);
+
+        if (value < min) min = value;
+        if (value > max) max = value;
+      }
+
+      return new Interval(min, max);
+    }
+
+    #region Equals, GetHashCode, == , !=
+    public bool Equals(Interval other) {
+      if (other == null)
+        return false;
+
+      return (UpperBound.IsAlmost(other.UpperBound) || (double.IsNaN(UpperBound) && double.IsNaN(other.UpperBound)))
+        && (LowerBound.IsAlmost(other.LowerBound) || (double.IsNaN(LowerBound) && double.IsNaN(other.LowerBound)));
+    }
+
+    public override bool Equals(object obj) {
+      return Equals(obj as Interval);
+    }
+
+    public override int GetHashCode() {
+      return LowerBound.GetHashCode() ^ UpperBound.GetHashCode();
+    }
+
+    public static bool operator ==(Interval interval1, Interval interval2) {
+      if (ReferenceEquals(interval1, null)) return ReferenceEquals(interval2, null);
+      return interval1.Equals(interval2);
+    }
+    public static bool operator !=(Interval interval1, Interval interval2) {
+      return !(interval1 == interval2);
+    }
+    #endregion
+
+    #region operations
+
+    // [x1,x2] + [y1,y2] = [x1 + y1,x2 + y2]
+    public static Interval Add(Interval a, Interval b) {
+      return new Interval(a.LowerBound + b.LowerBound, a.UpperBound + b.UpperBound);
+    }
+
+    // [x1,x2] − [y1,y2] = [x1 − y2,x2 − y1]
+    public static Interval Subtract(Interval a, Interval b) {
+      return new Interval(a.LowerBound - b.UpperBound, a.UpperBound - b.LowerBound);
+    }
+
+    // [x1,x2] * [y1,y2] = [min(x1*y1,x1*y2,x2*y1,x2*y2),max(x1*y1,x1*y2,x2*y1,x2*y2)]
+    public static Interval Multiply(Interval a, Interval b) {
+      double v1 = a.LowerBound * b.LowerBound;
+      double v2 = a.LowerBound * b.UpperBound;
+      double v3 = a.UpperBound * b.LowerBound;
+      double v4 = a.UpperBound * b.UpperBound;
+
+      double min = Math.Min(Math.Min(v1, v2), Math.Min(v3, v4));
+      double max = Math.Max(Math.Max(v1, v2), Math.Max(v3, v4));
+      return new Interval(min, max);
+    }
+
+    //Division by intervals containing 0 is implemented as defined in
+    //http://en.wikipedia.org/wiki/Interval_arithmetic
+    public static Interval Divide(Interval a, Interval b) {
+      if (b.Contains(0.0)) {
+        if (b.LowerBound.IsAlmost(0.0)) return Interval.Multiply(a, new Interval(1.0 / b.UpperBound, double.PositiveInfinity));
+        else if (b.UpperBound.IsAlmost(0.0)) return Interval.Multiply(a, new Interval(double.NegativeInfinity, 1.0 / b.LowerBound));
+        else return new Interval(double.NegativeInfinity, double.PositiveInfinity);
+      }
+      return Interval.Multiply(a, new Interval(1.0 / b.UpperBound, 1.0 / b.LowerBound));
+    }
+
+    public static Interval Sine(Interval a) {
+      if (Math.Abs(a.UpperBound - a.LowerBound) >= Math.PI * 2) return new Interval(-1, 1);
+
+      //divide the interval by PI/2 so that the optima lie at x element of N (0,1,2,3,4,...)
+      double Pihalf = Math.PI / 2;
+      Interval scaled = Interval.Divide(a, new Interval(Pihalf, Pihalf));
+      //move to positive scale
+      if (scaled.LowerBound < 0) {
+        int periodsToMove = Math.Abs((int)scaled.LowerBound / 4) + 1;
+        scaled = Interval.Add(scaled, new Interval(periodsToMove * 4, periodsToMove * 4));
+      }
+
+      double scaledLowerBound = scaled.LowerBound % 4.0;
+      double scaledUpperBound = scaled.UpperBound % 4.0;
+      if (scaledUpperBound < scaledLowerBound) scaledUpperBound += 4.0;
+      List<double> sinValues = new List<double>();
+      sinValues.Add(Math.Sin(scaledLowerBound * Pihalf));
+      sinValues.Add(Math.Sin(scaledUpperBound * Pihalf));
+
+      int startValue = (int)Math.Ceiling(scaledLowerBound);
+      while (startValue < scaledUpperBound) {
+        sinValues.Add(Math.Sin(startValue * Pihalf));
+        startValue += 1;
+      }
+
+      return new Interval(sinValues.Min(), sinValues.Max());
+    }
+    public static Interval Cosine(Interval a) {
+      return Interval.Sine(Interval.Add(a, new Interval(Math.PI / 2, Math.PI / 2)));
+    }
+    public static Interval Tangens(Interval a) {
+      return Interval.Divide(Interval.Sine(a), Interval.Cosine(a));
+    }
+    public static Interval HyperbolicTangent(Interval a) {
+      return new Interval(Math.Tanh(a.LowerBound), Math.Tanh(a.UpperBound));
+    }
+
+    public static Interval Logarithm(Interval a) {
+      return new Interval(Math.Log(a.LowerBound), Math.Log(a.UpperBound));
+    }
+    public static Interval Exponential(Interval a) {
+      return new Interval(Math.Exp(a.LowerBound), Math.Exp(a.UpperBound));
+    }
+
+    public static Interval Square(Interval a) {
+      if (a.UpperBound <= 0) return new Interval(a.UpperBound * a.UpperBound, a.LowerBound * a.LowerBound);     // interval is negative
+      else if (a.LowerBound >= 0) return new Interval(a.LowerBound * a.LowerBound, a.UpperBound * a.UpperBound); // interval is positive
+      else return new Interval(0, Math.Max(a.LowerBound * a.LowerBound, a.UpperBound * a.UpperBound)); // interval goes over zero
+    }
+
+    public static Interval Cube(Interval a) {
+      return new Interval(Math.Pow(a.LowerBound, 3), Math.Pow(a.UpperBound, 3));
+    }
+
+    /// <summary>
+    /// The interval contains both possible results of the calculated square root +-sqrt(x). That results in a wider
+    /// interval, but it contains all possible solutions.
+    /// </summary>
+    /// <param name="a">Interval to build square root from.</param>
+    /// <returns></returns>
+    public static Interval SquareRoot(Interval a) {
+      if (a.LowerBound < 0) return new Interval(double.NaN, double.NaN);
+      return new Interval(-Math.Sqrt(a.UpperBound), Math.Sqrt(a.UpperBound));
+    }
+
+    public static Interval CubicRoot(Interval a) {
+      var lower = (a.LowerBound < 0) ? -Math.Pow(-a.LowerBound, 1d / 3d) : Math.Pow(a.LowerBound, 1d / 3d);
+      var upper = (a.UpperBound < 0) ? -Math.Pow(-a.UpperBound, 1d / 3d) : Math.Pow(a.UpperBound, 1d / 3d);
+
+      return new Interval(lower, upper);
+    }
+
+    public static Interval Absolute(Interval a) {
+      var absLower = Math.Abs(a.LowerBound);
+      var absUpper = Math.Abs(a.UpperBound);
+      var min = Math.Min(absLower, absUpper);
+      var max = Math.Max(absLower, absUpper);
+
+      if (a.Contains(0.0)) {
+        min = 0.0;
+      }
+
+      return new Interval(min, max);
+    }
+
+    public static Interval AnalyticalQuotient(Interval a, Interval b) {
+      var dividend = a;
+      var divisor = Add(Square(b), new Interval(1.0, 1.0));
+      divisor = SquareRoot(divisor);
+
+      var quotient = Divide(dividend, divisor);
+      return quotient;
+    }
+    #endregion
+  }
+}
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 17803)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 17803)
@@ -0,0 +1,102 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  [Item("IntervalCollection", "Represents variables with their interval ranges.")]
+  [StorableType("230B4E4B-41E5-4D33-9BC3-E2DAADDCA5AE")]
+  public class IntervalCollection : Item {
+    public static new System.Drawing.Image StaticItemImage {
+      get => HeuristicLab.Common.Resources.VSImageLibrary.Object;
+    }
+    private IDictionary<string, Interval> intervals { get; } = new Dictionary<string, Interval>();
+
+    [Storable(Name = "StorableIntervalInformation")]
+    private KeyValuePair<string, double[]>[] StorableIntervalInformation {
+      get {
+        var l = new List<KeyValuePair<string, double[]>>();
+        foreach (var varInt in intervals)
+
+          l.Add(new KeyValuePair<string, double[]>(varInt.Key,
+            new double[] { varInt.Value.LowerBound, varInt.Value.UpperBound }));
+        return l.ToArray();
+      }
+
+      set {
+        foreach (var varInt in value)
+          intervals.Add(varInt.Key, new Interval(varInt.Value[0], varInt.Value[1]));
+      }
+    }
+
+    public int Count => intervals.Count;
+
+    public IntervalCollection() : base() { }
+    [StorableConstructor]
+    protected IntervalCollection(StorableConstructorFlag _) : base(_) { }
+
+    protected IntervalCollection(IntervalCollection original, Cloner cloner) : base(original, cloner) {
+      foreach (var keyValuePair in original.intervals) {
+        intervals.Add(keyValuePair.Key, new Interval(keyValuePair.Value.LowerBound, keyValuePair.Value.UpperBound));
+      }
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new IntervalCollection(this, cloner);
+    }
+
+    public IntervalCollection(IDictionary<string, Interval> intervals) {
+      this.intervals = intervals;
+    }
+
+    public Interval GetInterval(string identifier) {
+      if (!intervals.ContainsKey(identifier)) throw new ArgumentException($"The given identifier:{ identifier } is not present!");
+
+      return intervals[identifier];
+    }
+
+    public void SetInterval(string identifier, Interval interval) {
+      intervals[identifier] = interval;
+    }
+
+    public void AddInterval(string identifier, Interval interval) {
+      intervals.Add(identifier, interval);
+    }
+
+    public void DeleteInterval(string identifier) {
+      intervals.Remove(identifier);
+    }
+
+    public IReadOnlyDictionary<string, Interval> GetReadonlyDictionary() {
+      return intervals.ToDictionary(pair => pair.Key, pair => pair.Value);
+    }
+
+    public IEnumerable<Tuple<string, Interval>> GetVariableIntervals() {
+      foreach (var variableInterval in intervals)
+        yield return Tuple.Create(variableInterval.Key, variableInterval.Value);
+    }
+  }
+}
+
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 17803)
@@ -1,3 +1,3 @@
-#region License Information
+﻿#region License Information
 /* HeuristicLab
  * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -23,9 +23,9 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis {
@@ -34,4 +34,6 @@
   public class RegressionProblemData : DataAnalysisProblemData, IRegressionProblemData, IStorableContent {
     protected const string TargetVariableParameterName = "TargetVariable";
+    protected const string VariableRangesParameterName = "VariableRanges";
+    protected const string IntervalConstraintsParameterName = "IntervalConstraints";
     public string Filename { get; set; }
 
@@ -91,4 +93,5 @@
       problemData.Parameters.Add(new FixedValueParameter<IntRange>(TestPartitionParameterName, "", (IntRange)new IntRange(0, 0).AsReadOnly()));
       problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>()));
+      problemData.Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, "", new IntervalCollection()));
       emptyProblemData = problemData;
     }
@@ -98,4 +101,12 @@
       get { return (IConstrainedValueParameter<StringValue>)Parameters[TargetVariableParameterName]; }
     }
+
+    public IFixedValueParameter<IntervalCollection> VariableRangesParameter => (IFixedValueParameter<IntervalCollection>)Parameters[VariableRangesParameterName];
+
+    public IntervalCollection VariableRanges {
+      get => VariableRangesParameter.Value;
+    }
+
+
     public string TargetVariable {
       get { return TargetVariableParameter.Value.Value; }
@@ -125,4 +136,8 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
+      if (!Parameters.ContainsKey(VariableRangesParameterName)) {
+        var intervalCollection = CalculateDatasetIntervals(this.Dataset);
+        Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
+      }
       RegisterParameterEvents();
     }
@@ -152,5 +167,17 @@
       var variables = InputVariables.Select(x => x.AsReadOnly()).ToList();
       Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>(variables), variables.Where(x => x.Value == targetVariable).First()));
+      var intervalCollection = CalculateDatasetIntervals(this.Dataset);
+      Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, intervalCollection));
       RegisterParameterEvents();
+    }
+
+    private static IntervalCollection CalculateDatasetIntervals(IDataset dataset) {
+      IntervalCollection intervalCollection = new IntervalCollection();
+      foreach (var variable in dataset.DoubleVariables) {// intervals are only possible for double variables
+        var variableInterval = Interval.GetInterval(dataset.GetDoubleValues(variable));
+        intervalCollection.AddInterval(variable, variableInterval);
+      }
+
+      return intervalCollection;
     }
 
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisModel.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisModel.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisModel.cs	(revision 17803)
@@ -25,9 +25,9 @@
 
 namespace HeuristicLab.Problems.DataAnalysis {
-  [StorableType("f85ccf7a-7df5-431e-bc4d-be6f3c4c2338")]
   /// <summary>
   /// Interface for all data-analysis models (regression/classification/clustering).
   /// <remarks>All methods and properties in in this interface must be implemented thread safely</remarks>
   /// </summary>
+  [StorableType("f85ccf7a-7df5-431e-bc4d-be6f3c4c2338")]
   public interface IDataAnalysisModel : INamedItem {
     IEnumerable<string> VariablesUsedForPrediction { get; }
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblem.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblem.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisProblem.cs	(revision 17803)
@@ -35,5 +35,5 @@
   [StorableType("c2f6fcdd-ab62-4423-be75-01aa694df411")]
   public interface IDataAnalysisProblem<T> : IDataAnalysisProblem
-  where T : class, IDataAnalysisProblemData {
+    where T : class, IDataAnalysisProblemData {
     new IValueParameter<T> ProblemDataParameter { get; }
     new T ProblemData { get; set; }
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDependencyCalculator.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDependencyCalculator.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDependencyCalculator.cs	(revision 17803)
@@ -22,6 +22,8 @@
 using System;
 using System.Collections.Generic;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis {
+  [StorableType("3283B3FB-8467-4B99-9B6E-23BF3D1B8505")]
   public interface IDependencyCalculator {
     double Maximum { get; }
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IOnlineCalculator.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IOnlineCalculator.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IOnlineCalculator.cs	(revision 17803)
@@ -22,6 +22,9 @@
 
 using System;
+using HEAL.Attic;
+
 namespace HeuristicLab.Problems.DataAnalysis {
   [Flags]
+  [StorableType("8A28DDA1-4814-4B77-9457-0EE930BE9C73")]
   public enum OnlineCalculatorError {
     /// <summary>
@@ -38,4 +41,6 @@
     InsufficientElementsAdded = 2
   }
+
+  [StorableType("119C8242-3EE7-4C34-A7AC-68ABF76EB11B")]
   public interface IOnlineCalculator {
     OnlineCalculatorError ErrorState { get; }
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionProblemData.cs	(revision 17803)
@@ -28,4 +28,6 @@
     string TargetVariable { get; set; }
 
+    IntervalCollection VariableRanges { get;}
+
     IEnumerable<double> TargetVariableValues { get; }
     IEnumerable<double> TargetVariableTrainingValues { get; }
Index: stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/TimeSeriesPrognosis/IOnlineTimeSeriesCalculator.cs
===================================================================
--- stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/TimeSeriesPrognosis/IOnlineTimeSeriesCalculator.cs	(revision 17495)
+++ stable/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/TimeSeriesPrognosis/IOnlineTimeSeriesCalculator.cs	(revision 17803)
@@ -22,6 +22,8 @@
 
 using System.Collections.Generic;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis {
+  [StorableType("7461AC5D-9D9A-4DCD-B32F-602260E58FFC")]
   public interface IOnlineTimeSeriesCalculator {
     OnlineCalculatorError ErrorState { get; }
